/* key-event.c generated by valac 0.18.0.121-83f92, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2013 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2013 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define KKC_TYPE_MODIFIER_TYPE (kkc_modifier_type_get_type ())

#define KKC_TYPE_KEY_EVENT (kkc_key_event_get_type ())
#define KKC_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEvent))
#define KKC_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))
#define KKC_IS_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_KEY_EVENT))
#define KKC_IS_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_KEY_EVENT))
#define KKC_KEY_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))

typedef struct _KkcKeyEvent KkcKeyEvent;
typedef struct _KkcKeyEventClass KkcKeyEventClass;
typedef struct _KkcKeyEventPrivate KkcKeyEventPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define KKC_KEY_EVENT_TYPE_CODE_KEYVAL_ENTRY (kkc_key_event_code_keyval_entry_get_type ())
typedef struct _KkcKeyEventCodeKeyvalEntry KkcKeyEventCodeKeyvalEntry;

#define KKC_KEY_EVENT_TYPE_NAME_KEYVAL_ENTRY (kkc_key_event_name_keyval_entry_get_type ())
typedef struct _KkcKeyEventNameKeyvalEntry KkcKeyEventNameKeyvalEntry;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED,
	KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND
} KkcKeyEventFormatError;
#define KKC_KEY_EVENT_FORMAT_ERROR kkc_key_event_format_error_quark ()
typedef enum  {
	KKC_MODIFIER_TYPE_NONE = 0,
	KKC_MODIFIER_TYPE_SHIFT_MASK = 1 << 0,
	KKC_MODIFIER_TYPE_LOCK_MASK = 1 << 1,
	KKC_MODIFIER_TYPE_CONTROL_MASK = 1 << 2,
	KKC_MODIFIER_TYPE_MOD1_MASK = 1 << 3,
	KKC_MODIFIER_TYPE_MOD2_MASK = 1 << 4,
	KKC_MODIFIER_TYPE_MOD3_MASK = 1 << 5,
	KKC_MODIFIER_TYPE_MOD4_MASK = 1 << 6,
	KKC_MODIFIER_TYPE_MOD5_MASK = 1 << 7,
	KKC_MODIFIER_TYPE_LSHIFT_MASK = 1 << 22,
	KKC_MODIFIER_TYPE_RSHIFT_MASK = 1 << 23,
	KKC_MODIFIER_TYPE_USLEEP_MASK = 1 << 24,
	KKC_MODIFIER_TYPE_SUPER_MASK = 1 << 26,
	KKC_MODIFIER_TYPE_HYPER_MASK = 1 << 27,
	KKC_MODIFIER_TYPE_META_MASK = 1 << 28,
	KKC_MODIFIER_TYPE_RELEASE_MASK = 1 << 30
} KkcModifierType;

struct _KkcKeyEvent {
	GObject parent_instance;
	KkcKeyEventPrivate * priv;
};

struct _KkcKeyEventClass {
	GObjectClass parent_class;
};

struct _KkcKeyEventPrivate {
	gchar* _name;
	gunichar _code;
	guint _keycode;
	KkcModifierType _modifiers;
	guint _keyval;
};

struct _KkcKeyEventCodeKeyvalEntry {
	guint key;
	gunichar value;
};

struct _KkcKeyEventNameKeyvalEntry {
	guint key;
	gchar* value;
};


static gpointer kkc_key_event_parent_class = NULL;

GQuark kkc_key_event_format_error_quark (void);
GType kkc_modifier_type_get_type (void) G_GNUC_CONST;
GType kkc_key_event_get_type (void) G_GNUC_CONST;
#define KKC_KEY_EVENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), KKC_TYPE_KEY_EVENT, KkcKeyEventPrivate))
enum  {
	KKC_KEY_EVENT_DUMMY_PROPERTY,
	KKC_KEY_EVENT_NAME,
	KKC_KEY_EVENT_CODE,
	KKC_KEY_EVENT_KEYCODE,
	KKC_KEY_EVENT_MODIFIERS,
	KKC_KEY_EVENT_KEYVAL
};
#define KKC_KEYSYMS_VoidSymbol ((guint) 0xffffff)
static GType kkc_key_event_code_keyval_entry_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static KkcKeyEventCodeKeyvalEntry* kkc_key_event_code_keyval_entry_dup (const KkcKeyEventCodeKeyvalEntry* self);
static void kkc_key_event_code_keyval_entry_free (KkcKeyEventCodeKeyvalEntry* self);
#define KKC_KEYSYMS_Tab ((guint) 0xff09)
#define KKC_KEYSYMS_Return ((guint) 0xff0d)
#define KKC_KEYSYMS_BackSpace ((guint) 0xff08)
static GType kkc_key_event_name_keyval_entry_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static KkcKeyEventNameKeyvalEntry* kkc_key_event_name_keyval_entry_dup (const KkcKeyEventNameKeyvalEntry* self);
static void kkc_key_event_name_keyval_entry_free (KkcKeyEventNameKeyvalEntry* self);
static void kkc_key_event_name_keyval_entry_copy (const KkcKeyEventNameKeyvalEntry* self, KkcKeyEventNameKeyvalEntry* dest);
static void kkc_key_event_name_keyval_entry_destroy (KkcKeyEventNameKeyvalEntry* self);
#define KKC_KEYSYMS_space ((guint) 0x0020)
#define KKC_KEYSYMS_Escape ((guint) 0xff1b)
#define KKC_KEYSYMS_Up ((guint) 0xff52)
#define KKC_KEYSYMS_Down ((guint) 0xff54)
#define KKC_KEYSYMS_Left ((guint) 0xff51)
#define KKC_KEYSYMS_Right ((guint) 0xff53)
#define KKC_KEYSYMS_Page_Up ((guint) 0xff55)
#define KKC_KEYSYMS_KP_Page_Up ((guint) 0xff9a)
#define KKC_KEYSYMS_Page_Down ((guint) 0xff56)
#define KKC_KEYSYMS_KP_Page_Down ((guint) 0xff9b)
#define KKC_KEYSYMS_Muhenkan ((guint) 0xff22)
#define KKC_KEYSYMS_Henkan ((guint) 0xff23)
#define KKC_KEYSYMS_Hiragana_Katakana ((guint) 0xff27)
#define KKC_KEYSYMS_Eisu_toggle ((guint) 0xff30)
KkcKeyEvent* kkc_key_event_new (const gchar* name, gunichar code, KkcModifierType modifiers);
KkcKeyEvent* kkc_key_event_construct (GType object_type, const gchar* name, gunichar code, KkcModifierType modifiers);
static void kkc_key_event_set_name (KkcKeyEvent* self, const gchar* value);
static void kkc_key_event_set_code (KkcKeyEvent* self, gunichar value);
void kkc_key_event_set_modifiers (KkcKeyEvent* self, KkcModifierType value);
KkcKeyEvent* kkc_key_event_copy (KkcKeyEvent* self);
const gchar* kkc_key_event_get_name (KkcKeyEvent* self);
gunichar kkc_key_event_get_code (KkcKeyEvent* self);
KkcModifierType kkc_key_event_get_modifiers (KkcKeyEvent* self);
KkcKeyEvent* kkc_key_event_new_from_string (const gchar* key, GError** error);
KkcKeyEvent* kkc_key_event_construct_from_string (GType object_type, const gchar* key, GError** error);
gchar* kkc_key_event_to_string (KkcKeyEvent* self);
KkcKeyEvent* kkc_key_event_new_from_x_keysym (guint keyval, KkcModifierType modifiers, GError** error);
KkcKeyEvent* kkc_key_event_construct_from_x_keysym (GType object_type, guint keyval, KkcModifierType modifiers, GError** error);
KkcKeyEvent* kkc_key_event_new_from_x_event (guint keyval, guint keycode, KkcModifierType modifiers, GError** error);
KkcKeyEvent* kkc_key_event_construct_from_x_event (GType object_type, guint keyval, guint keycode, KkcModifierType modifiers, GError** error);
void kkc_key_event_set_keyval (KkcKeyEvent* self, guint value);
void kkc_key_event_set_keycode (KkcKeyEvent* self, guint value);
gboolean kkc_key_event_base_equal (KkcKeyEvent* self, KkcKeyEvent* key);
guint kkc_key_event_get_keycode (KkcKeyEvent* self);
guint kkc_key_event_get_keyval (KkcKeyEvent* self);
static void kkc_key_event_finalize (GObject* obj);
static void _vala_kkc_key_event_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_kkc_key_event_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const KkcKeyEventCodeKeyvalEntry KKC_KEY_EVENT_CODE_KEYVALS[3] = {{KKC_KEYSYMS_Tab, (gunichar) '\t'}, {KKC_KEYSYMS_Return, (gunichar) '\n'}, {KKC_KEYSYMS_BackSpace, (gunichar) '\b'}};
static const KkcKeyEventNameKeyvalEntry KKC_KEY_EVENT_NAME_KEYVALS[17] = {{KKC_KEYSYMS_space, "space"}, {KKC_KEYSYMS_Tab, "Tab"}, {KKC_KEYSYMS_Return, "Return"}, {KKC_KEYSYMS_BackSpace, "BackSpace"}, {KKC_KEYSYMS_Escape, "Escape"}, {KKC_KEYSYMS_Up, "Up"}, {KKC_KEYSYMS_Down, "Down"}, {KKC_KEYSYMS_Left, "Left"}, {KKC_KEYSYMS_Right, "Right"}, {KKC_KEYSYMS_Page_Up, "Page_Up"}, {KKC_KEYSYMS_KP_Page_Up, "Page_Up"}, {KKC_KEYSYMS_Page_Down, "Page_Down"}, {KKC_KEYSYMS_KP_Page_Down, "Page_Down"}, {KKC_KEYSYMS_Muhenkan, "lshift"}, {KKC_KEYSYMS_Henkan, "rshift"}, {KKC_KEYSYMS_Hiragana_Katakana, "Hiragana_Katakana"}, {KKC_KEYSYMS_Eisu_toggle, "Eisu_toggle"}};

GQuark kkc_key_event_format_error_quark (void) {
	return g_quark_from_static_string ("kkc_key_event_format_error-quark");
}


/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
GType kkc_modifier_type_get_type (void) {
	static volatile gsize kkc_modifier_type_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_modifier_type_type_id__volatile)) {
		static const GEnumValue values[] = {{KKC_MODIFIER_TYPE_NONE, "KKC_MODIFIER_TYPE_NONE", "none"}, {KKC_MODIFIER_TYPE_SHIFT_MASK, "KKC_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {KKC_MODIFIER_TYPE_LOCK_MASK, "KKC_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {KKC_MODIFIER_TYPE_CONTROL_MASK, "KKC_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {KKC_MODIFIER_TYPE_MOD1_MASK, "KKC_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {KKC_MODIFIER_TYPE_MOD2_MASK, "KKC_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {KKC_MODIFIER_TYPE_MOD3_MASK, "KKC_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {KKC_MODIFIER_TYPE_MOD4_MASK, "KKC_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {KKC_MODIFIER_TYPE_MOD5_MASK, "KKC_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {KKC_MODIFIER_TYPE_LSHIFT_MASK, "KKC_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {KKC_MODIFIER_TYPE_RSHIFT_MASK, "KKC_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {KKC_MODIFIER_TYPE_USLEEP_MASK, "KKC_MODIFIER_TYPE_USLEEP_MASK", "usleep-mask"}, {KKC_MODIFIER_TYPE_SUPER_MASK, "KKC_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {KKC_MODIFIER_TYPE_HYPER_MASK, "KKC_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {KKC_MODIFIER_TYPE_META_MASK, "KKC_MODIFIER_TYPE_META_MASK", "meta-mask"}, {KKC_MODIFIER_TYPE_RELEASE_MASK, "KKC_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
		GType kkc_modifier_type_type_id;
		kkc_modifier_type_type_id = g_enum_register_static ("KkcModifierType", values);
		g_once_init_leave (&kkc_modifier_type_type_id__volatile, kkc_modifier_type_type_id);
	}
	return kkc_modifier_type_type_id__volatile;
}


/**
         * Create a key event.
         *
         * @param name a key name
         * @param code a character code
         * @param modifiers state of modifier keys
         *
         * @return a new KeyEvent
         */
KkcKeyEvent* kkc_key_event_construct (GType object_type, const gchar* name, gunichar code, KkcModifierType modifiers) {
	KkcKeyEvent * self = NULL;
	const gchar* _tmp0_;
	gunichar _tmp1_;
	KkcModifierType _tmp2_;
	self = (KkcKeyEvent*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	kkc_key_event_set_name (self, _tmp0_);
	_tmp1_ = code;
	kkc_key_event_set_code (self, _tmp1_);
	_tmp2_ = modifiers;
	kkc_key_event_set_modifiers (self, _tmp2_);
	return self;
}


KkcKeyEvent* kkc_key_event_new (const gchar* name, gunichar code, KkcModifierType modifiers) {
	return kkc_key_event_construct (KKC_TYPE_KEY_EVENT, name, code, modifiers);
}


/**
         * Create a copy of the key event.
         *
         * @return a new KeyEvent
         */
KkcKeyEvent* kkc_key_event_copy (KkcKeyEvent* self) {
	KkcKeyEvent* result = NULL;
	const gchar* _tmp0_;
	gunichar _tmp1_;
	KkcModifierType _tmp2_;
	KkcKeyEvent* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	_tmp1_ = self->priv->_code;
	_tmp2_ = self->priv->_modifiers;
	_tmp3_ = kkc_key_event_new (_tmp0_, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	glong string_length;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_;
	gboolean _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp14_ = end;
	if (_tmp14_ >= ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = end;
		_tmp16_ = string_length;
		_tmp13_ = _tmp15_ <= _tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp17_ = _tmp13_;
	g_return_val_if_fail (_tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
	_tmp20_ = start;
	_tmp21_ = end;
	_tmp22_ = start;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
	result = _tmp23_;
	return result;
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	result = _tmp1_;
	return result;
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _result_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


KkcKeyEvent* kkc_key_event_construct_from_string (GType object_type, const gchar* key, GError** error) {
	KkcKeyEvent * self = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (key != NULL, NULL);
	self = (KkcKeyEvent*) g_object_new (object_type, NULL);
	_tmp1_ = key;
	_tmp2_ = g_str_has_prefix (_tmp1_, "(");
	if (_tmp2_) {
		const gchar* _tmp3_;
		gboolean _tmp4_ = FALSE;
		_tmp3_ = key;
		_tmp4_ = g_str_has_suffix (_tmp3_, ")");
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = _tmp0_;
	if (_tmp5_) {
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_ = NULL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar** strv;
		gint strv_length1;
		gint _strv_size_;
		gint index;
		gchar** _tmp61_;
		gint _tmp61__length1;
		gint _tmp62_;
		const gchar* _tmp63_;
		gunichar _tmp64_ = 0U;
		const gchar* _tmp65_;
		gint _tmp66_ = 0;
		gunichar _tmp69_;
		_tmp6_ = key;
		_tmp7_ = string_slice (_tmp6_, (glong) 1, (glong) (-1));
		_tmp8_ = _tmp7_;
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 0);
		_tmp11_ = _tmp10_;
		_tmp11__length1 = _vala_array_length (_tmp9_);
		_g_free0 (_tmp8_);
		strv = _tmp11_;
		strv_length1 = _tmp11__length1;
		_strv_size_ = strv_length1;
		index = 0;
		{
			gboolean _tmp12_;
			_tmp12_ = TRUE;
			while (TRUE) {
				gboolean _tmp13_;
				gint _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				const gchar* _tmp19_;
				_tmp13_ = _tmp12_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = index;
					index = _tmp14_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp15_ = index;
				_tmp16_ = strv;
				_tmp16__length1 = strv_length1;
				if (!(_tmp15_ < (_tmp16__length1 - 1))) {
					break;
				}
				_tmp17_ = strv;
				_tmp17__length1 = strv_length1;
				_tmp18_ = index;
				_tmp19_ = _tmp17_[_tmp18_];
				if (g_strcmp0 (_tmp19_, "shift") == 0) {
					KkcModifierType _tmp20_;
					_tmp20_ = self->priv->_modifiers;
					kkc_key_event_set_modifiers (self, _tmp20_ | KKC_MODIFIER_TYPE_SHIFT_MASK);
				} else {
					gchar** _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					const gchar* _tmp23_;
					_tmp21_ = strv;
					_tmp21__length1 = strv_length1;
					_tmp22_ = index;
					_tmp23_ = _tmp21_[_tmp22_];
					if (g_strcmp0 (_tmp23_, "control") == 0) {
						KkcModifierType _tmp24_;
						_tmp24_ = self->priv->_modifiers;
						kkc_key_event_set_modifiers (self, _tmp24_ | KKC_MODIFIER_TYPE_CONTROL_MASK);
					} else {
						gchar** _tmp25_;
						gint _tmp25__length1;
						gint _tmp26_;
						const gchar* _tmp27_;
						_tmp25_ = strv;
						_tmp25__length1 = strv_length1;
						_tmp26_ = index;
						_tmp27_ = _tmp25_[_tmp26_];
						if (g_strcmp0 (_tmp27_, "meta") == 0) {
							KkcModifierType _tmp28_;
							_tmp28_ = self->priv->_modifiers;
							kkc_key_event_set_modifiers (self, _tmp28_ | KKC_MODIFIER_TYPE_META_MASK);
						} else {
							gchar** _tmp29_;
							gint _tmp29__length1;
							gint _tmp30_;
							const gchar* _tmp31_;
							_tmp29_ = strv;
							_tmp29__length1 = strv_length1;
							_tmp30_ = index;
							_tmp31_ = _tmp29_[_tmp30_];
							if (g_strcmp0 (_tmp31_, "hyper") == 0) {
								KkcModifierType _tmp32_;
								_tmp32_ = self->priv->_modifiers;
								kkc_key_event_set_modifiers (self, _tmp32_ | KKC_MODIFIER_TYPE_HYPER_MASK);
							} else {
								gchar** _tmp33_;
								gint _tmp33__length1;
								gint _tmp34_;
								const gchar* _tmp35_;
								_tmp33_ = strv;
								_tmp33__length1 = strv_length1;
								_tmp34_ = index;
								_tmp35_ = _tmp33_[_tmp34_];
								if (g_strcmp0 (_tmp35_, "super") == 0) {
									KkcModifierType _tmp36_;
									_tmp36_ = self->priv->_modifiers;
									kkc_key_event_set_modifiers (self, _tmp36_ | KKC_MODIFIER_TYPE_SUPER_MASK);
								} else {
									gchar** _tmp37_;
									gint _tmp37__length1;
									gint _tmp38_;
									const gchar* _tmp39_;
									_tmp37_ = strv;
									_tmp37__length1 = strv_length1;
									_tmp38_ = index;
									_tmp39_ = _tmp37_[_tmp38_];
									if (g_strcmp0 (_tmp39_, "alt") == 0) {
										KkcModifierType _tmp40_;
										_tmp40_ = self->priv->_modifiers;
										kkc_key_event_set_modifiers (self, _tmp40_ | KKC_MODIFIER_TYPE_MOD1_MASK);
									} else {
										gchar** _tmp41_;
										gint _tmp41__length1;
										gint _tmp42_;
										const gchar* _tmp43_;
										_tmp41_ = strv;
										_tmp41__length1 = strv_length1;
										_tmp42_ = index;
										_tmp43_ = _tmp41_[_tmp42_];
										if (g_strcmp0 (_tmp43_, "lshift") == 0) {
											KkcModifierType _tmp44_;
											_tmp44_ = self->priv->_modifiers;
											kkc_key_event_set_modifiers (self, _tmp44_ | KKC_MODIFIER_TYPE_LSHIFT_MASK);
										} else {
											gchar** _tmp45_;
											gint _tmp45__length1;
											gint _tmp46_;
											const gchar* _tmp47_;
											_tmp45_ = strv;
											_tmp45__length1 = strv_length1;
											_tmp46_ = index;
											_tmp47_ = _tmp45_[_tmp46_];
											if (g_strcmp0 (_tmp47_, "rshift") == 0) {
												KkcModifierType _tmp48_;
												_tmp48_ = self->priv->_modifiers;
												kkc_key_event_set_modifiers (self, _tmp48_ | KKC_MODIFIER_TYPE_RSHIFT_MASK);
											} else {
												gchar** _tmp49_;
												gint _tmp49__length1;
												gint _tmp50_;
												const gchar* _tmp51_;
												_tmp49_ = strv;
												_tmp49__length1 = strv_length1;
												_tmp50_ = index;
												_tmp51_ = _tmp49_[_tmp50_];
												if (g_strcmp0 (_tmp51_, "usleep") == 0) {
													KkcModifierType _tmp52_;
													_tmp52_ = self->priv->_modifiers;
													kkc_key_event_set_modifiers (self, _tmp52_ | KKC_MODIFIER_TYPE_USLEEP_MASK);
												} else {
													gchar** _tmp53_;
													gint _tmp53__length1;
													gint _tmp54_;
													const gchar* _tmp55_;
													_tmp53_ = strv;
													_tmp53__length1 = strv_length1;
													_tmp54_ = index;
													_tmp55_ = _tmp53_[_tmp54_];
													if (g_strcmp0 (_tmp55_, "release") == 0) {
														KkcModifierType _tmp56_;
														_tmp56_ = self->priv->_modifiers;
														kkc_key_event_set_modifiers (self, _tmp56_ | KKC_MODIFIER_TYPE_RELEASE_MASK);
													} else {
														gchar** _tmp57_;
														gint _tmp57__length1;
														gint _tmp58_;
														const gchar* _tmp59_;
														GError* _tmp60_;
														_tmp57_ = strv;
														_tmp57__length1 = strv_length1;
														_tmp58_ = index;
														_tmp59_ = _tmp57_[_tmp58_];
														_tmp60_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp59_);
														_inner_error_ = _tmp60_;
														if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
															g_propagate_error (error, _inner_error_);
															strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
															_g_object_unref0 (self);
															return NULL;
														} else {
															strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
															g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
															g_clear_error (&_inner_error_);
															return NULL;
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		_tmp61_ = strv;
		_tmp61__length1 = strv_length1;
		_tmp62_ = index;
		_tmp63_ = _tmp61_[_tmp62_];
		kkc_key_event_set_name (self, _tmp63_);
		_tmp65_ = self->priv->_name;
		_tmp66_ = g_utf8_strlen (_tmp65_, (gssize) (-1));
		if (_tmp66_ == 1) {
			const gchar* _tmp67_;
			gunichar _tmp68_ = 0U;
			_tmp67_ = self->priv->_name;
			_tmp68_ = string_get_char (_tmp67_, (glong) 0);
			_tmp64_ = _tmp68_;
		} else {
			_tmp64_ = (gunichar) '\0';
		}
		_tmp69_ = _tmp64_;
		kkc_key_event_set_code (self, _tmp69_);
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	} else {
		const gchar* _tmp70_;
		gint _tmp71_ = 0;
		gint index;
		gint _tmp72_;
		_tmp70_ = key;
		_tmp71_ = string_last_index_of (_tmp70_, "-", 0);
		index = _tmp71_;
		_tmp72_ = index;
		if (_tmp72_ > 0) {
			const gchar* _tmp73_;
			gint _tmp74_;
			gchar* _tmp75_ = NULL;
			gchar* _tmp76_;
			gchar** _tmp77_;
			gchar** _tmp78_ = NULL;
			gchar** _tmp79_;
			gint _tmp79__length1;
			gchar** mods;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp80_;
			gint _tmp80__length1;
			const gchar* _tmp92_;
			gint _tmp93_;
			gchar* _tmp94_ = NULL;
			gchar* _tmp95_;
			gunichar _tmp96_ = 0U;
			const gchar* _tmp97_;
			gint _tmp98_ = 0;
			gunichar _tmp101_;
			_tmp73_ = key;
			_tmp74_ = index;
			_tmp75_ = string_substring (_tmp73_, (glong) 0, (glong) _tmp74_);
			_tmp76_ = _tmp75_;
			_tmp78_ = _tmp77_ = g_strsplit (_tmp76_, "-", 0);
			_tmp79_ = _tmp78_;
			_tmp79__length1 = _vala_array_length (_tmp77_);
			_g_free0 (_tmp76_);
			mods = _tmp79_;
			mods_length1 = _tmp79__length1;
			_mods_size_ = mods_length1;
			_tmp80_ = mods;
			_tmp80__length1 = mods_length1;
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
				mod_collection = _tmp80_;
				mod_collection_length1 = _tmp80__length1;
				for (mod_it = 0; mod_it < _tmp80__length1; mod_it = mod_it + 1) {
					gchar* _tmp81_;
					gchar* mod = NULL;
					_tmp81_ = g_strdup (mod_collection[mod_it]);
					mod = _tmp81_;
					{
						const gchar* _tmp82_;
						_tmp82_ = mod;
						if (g_strcmp0 (_tmp82_, "S") == 0) {
							KkcModifierType _tmp83_;
							_tmp83_ = self->priv->_modifiers;
							kkc_key_event_set_modifiers (self, _tmp83_ | KKC_MODIFIER_TYPE_SHIFT_MASK);
						} else {
							const gchar* _tmp84_;
							_tmp84_ = mod;
							if (g_strcmp0 (_tmp84_, "C") == 0) {
								KkcModifierType _tmp85_;
								_tmp85_ = self->priv->_modifiers;
								kkc_key_event_set_modifiers (self, _tmp85_ | KKC_MODIFIER_TYPE_CONTROL_MASK);
							} else {
								const gchar* _tmp86_;
								_tmp86_ = mod;
								if (g_strcmp0 (_tmp86_, "A") == 0) {
									KkcModifierType _tmp87_;
									_tmp87_ = self->priv->_modifiers;
									kkc_key_event_set_modifiers (self, _tmp87_ | KKC_MODIFIER_TYPE_MOD1_MASK);
								} else {
									const gchar* _tmp88_;
									_tmp88_ = mod;
									if (g_strcmp0 (_tmp88_, "M") == 0) {
										KkcModifierType _tmp89_;
										_tmp89_ = self->priv->_modifiers;
										kkc_key_event_set_modifiers (self, _tmp89_ | KKC_MODIFIER_TYPE_META_MASK);
									} else {
										const gchar* _tmp90_;
										_tmp90_ = mod;
										if (g_strcmp0 (_tmp90_, "G") == 0) {
											KkcModifierType _tmp91_;
											_tmp91_ = self->priv->_modifiers;
											kkc_key_event_set_modifiers (self, _tmp91_ | KKC_MODIFIER_TYPE_MOD5_MASK);
										}
									}
								}
							}
						}
						_g_free0 (mod);
					}
				}
			}
			_tmp92_ = key;
			_tmp93_ = index;
			_tmp94_ = string_substring (_tmp92_, (glong) (_tmp93_ + 1), (glong) (-1));
			_tmp95_ = _tmp94_;
			kkc_key_event_set_name (self, _tmp95_);
			_g_free0 (_tmp95_);
			_tmp97_ = self->priv->_name;
			_tmp98_ = g_utf8_strlen (_tmp97_, (gssize) (-1));
			if (_tmp98_ == 1) {
				const gchar* _tmp99_;
				gunichar _tmp100_ = 0U;
				_tmp99_ = self->priv->_name;
				_tmp100_ = string_get_char (_tmp99_, (glong) 0);
				_tmp96_ = _tmp100_;
			} else {
				_tmp96_ = (gunichar) '\0';
			}
			_tmp101_ = _tmp96_;
			kkc_key_event_set_code (self, _tmp101_);
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
		} else {
			const gchar* _tmp102_;
			gunichar _tmp103_ = 0U;
			const gchar* _tmp104_;
			gint _tmp105_ = 0;
			gunichar _tmp108_;
			kkc_key_event_set_modifiers (self, KKC_MODIFIER_TYPE_NONE);
			_tmp102_ = key;
			kkc_key_event_set_name (self, _tmp102_);
			_tmp104_ = self->priv->_name;
			_tmp105_ = g_utf8_strlen (_tmp104_, (gssize) (-1));
			if (_tmp105_ == 1) {
				const gchar* _tmp106_;
				gunichar _tmp107_ = 0U;
				_tmp106_ = self->priv->_name;
				_tmp107_ = string_get_char (_tmp106_, (glong) 0);
				_tmp103_ = _tmp107_;
			} else {
				_tmp103_ = (gunichar) '\0';
			}
			_tmp108_ = _tmp103_;
			kkc_key_event_set_code (self, _tmp108_);
		}
	}
	return self;
}


KkcKeyEvent* kkc_key_event_new_from_string (const gchar* key, GError** error) {
	return kkc_key_event_construct_from_string (KKC_TYPE_KEY_EVENT, key, error);
}


/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* str;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


gchar* kkc_key_event_to_string (KkcKeyEvent* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _base;
	gboolean _tmp8_ = FALSE;
	gunichar _tmp9_;
	gboolean _tmp11_;
	KkcModifierType _tmp13_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_name;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = self->priv->_name;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_ = NULL;
		_tmp4_ = self->priv->_code;
		_tmp5_ = g_unichar_to_string (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _tmp0_;
	_tmp7_ = g_strdup (_tmp6_);
	_base = _tmp7_;
	_tmp9_ = self->priv->_code;
	if (((gunichar) 0x21) <= _tmp9_) {
		gunichar _tmp10_;
		_tmp10_ = self->priv->_code;
		_tmp8_ = _tmp10_ < ((gunichar) 0x7F);
	} else {
		_tmp8_ = FALSE;
	}
	_tmp11_ = _tmp8_;
	if (_tmp11_) {
		KkcModifierType _tmp12_;
		_tmp12_ = self->priv->_modifiers;
		kkc_key_event_set_modifiers (self, _tmp12_ & (~KKC_MODIFIER_TYPE_SHIFT_MASK));
	}
	_tmp13_ = self->priv->_modifiers;
	if (_tmp13_ != 0) {
		GeeArrayList* _tmp14_;
		GeeArrayList* elements;
		KkcModifierType _tmp15_;
		KkcModifierType _tmp17_;
		KkcModifierType _tmp19_;
		KkcModifierType _tmp21_;
		KkcModifierType _tmp23_;
		KkcModifierType _tmp25_;
		KkcModifierType _tmp27_;
		KkcModifierType _tmp29_;
		KkcModifierType _tmp31_;
		KkcModifierType _tmp33_;
		GeeArrayList* _tmp35_;
		const gchar* _tmp36_;
		GeeArrayList* _tmp37_;
		GeeArrayList* _tmp38_;
		gint _tmp39_ = 0;
		gpointer* _tmp40_ = NULL;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_ = NULL;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		_tmp14_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
		elements = _tmp14_;
		_tmp15_ = self->priv->_modifiers;
		if ((_tmp15_ & KKC_MODIFIER_TYPE_SHIFT_MASK) != 0) {
			GeeArrayList* _tmp16_;
			_tmp16_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, "shift");
		}
		_tmp17_ = self->priv->_modifiers;
		if ((_tmp17_ & KKC_MODIFIER_TYPE_CONTROL_MASK) != 0) {
			GeeArrayList* _tmp18_;
			_tmp18_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, "control");
		}
		_tmp19_ = self->priv->_modifiers;
		if ((_tmp19_ & KKC_MODIFIER_TYPE_META_MASK) != 0) {
			GeeArrayList* _tmp20_;
			_tmp20_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "meta");
		}
		_tmp21_ = self->priv->_modifiers;
		if ((_tmp21_ & KKC_MODIFIER_TYPE_HYPER_MASK) != 0) {
			GeeArrayList* _tmp22_;
			_tmp22_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, "hyper");
		}
		_tmp23_ = self->priv->_modifiers;
		if ((_tmp23_ & KKC_MODIFIER_TYPE_SUPER_MASK) != 0) {
			GeeArrayList* _tmp24_;
			_tmp24_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, "super");
		}
		_tmp25_ = self->priv->_modifiers;
		if ((_tmp25_ & KKC_MODIFIER_TYPE_MOD1_MASK) != 0) {
			GeeArrayList* _tmp26_;
			_tmp26_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "alt");
		}
		_tmp27_ = self->priv->_modifiers;
		if ((_tmp27_ & KKC_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
			GeeArrayList* _tmp28_;
			_tmp28_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, "lshift");
		}
		_tmp29_ = self->priv->_modifiers;
		if ((_tmp29_ & KKC_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
			GeeArrayList* _tmp30_;
			_tmp30_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, "rshift");
		}
		_tmp31_ = self->priv->_modifiers;
		if ((_tmp31_ & KKC_MODIFIER_TYPE_USLEEP_MASK) != 0) {
			GeeArrayList* _tmp32_;
			_tmp32_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, "usleep");
		}
		_tmp33_ = self->priv->_modifiers;
		if ((_tmp33_ & KKC_MODIFIER_TYPE_RELEASE_MASK) != 0) {
			GeeArrayList* _tmp34_;
			_tmp34_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, "release");
		}
		_tmp35_ = elements;
		_tmp36_ = _base;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
		_tmp37_ = elements;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, NULL);
		_tmp38_ = elements;
		_tmp40_ = gee_abstract_collection_to_array ((GeeAbstractCollection*) _tmp38_, &_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp41__length1 = _tmp39_;
		_tmp42_ = g_strjoinv (" ", _tmp41_);
		_tmp43_ = _tmp42_;
		_tmp44_ = g_strconcat ("(", _tmp43_, NULL);
		_tmp45_ = _tmp44_;
		_tmp46_ = g_strconcat (_tmp45_, ")", NULL);
		_tmp47_ = _tmp46_;
		_g_free0 (_tmp45_);
		_g_free0 (_tmp43_);
		_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
		result = _tmp47_;
		_g_object_unref0 (elements);
		_g_free0 (_base);
		_g_free0 (_tmp0_);
		return result;
	} else {
		result = _base;
		_g_free0 (_tmp0_);
		return result;
	}
	_g_free0 (_base);
	_g_free0 (_tmp0_);
}


/**
         * Create a key event from an X keysym and modifiers.
         *
         * @param keyval an X keysym
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
KkcKeyEvent* kkc_key_event_construct_from_x_keysym (GType object_type, guint keyval, KkcModifierType modifiers, GError** error) {
	KkcKeyEvent * self = NULL;
	guint _tmp0_;
	KkcModifierType _tmp1_;
	GError * _inner_error_ = NULL;
	_tmp0_ = keyval;
	_tmp1_ = modifiers;
	self = (KkcKeyEvent*) kkc_key_event_construct_from_x_event (object_type, _tmp0_, (guint) 0, _tmp1_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


KkcKeyEvent* kkc_key_event_new_from_x_keysym (guint keyval, KkcModifierType modifiers, GError** error) {
	return kkc_key_event_construct_from_x_keysym (KKC_TYPE_KEY_EVENT, keyval, modifiers, error);
}


/**
         * Create a key event from an X event.
         *
         * @param keyval an X keysym
         * @param keycode an X keycode
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
KkcKeyEvent* kkc_key_event_construct_from_x_event (GType object_type, guint keyval, guint keycode, KkcModifierType modifiers, GError** error) {
	KkcKeyEvent * self = NULL;
	gunichar _tmp10_;
	guint _tmp19_;
	guint _tmp20_;
	KkcModifierType _tmp21_;
	GError * _inner_error_ = NULL;
	self = (KkcKeyEvent*) g_object_new (object_type, NULL);
	{
		KkcKeyEventNameKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = KKC_KEY_EVENT_NAME_KEYVALS;
		entry_collection_length1 = G_N_ELEMENTS (KKC_KEY_EVENT_NAME_KEYVALS);
		for (entry_it = 0; entry_it < G_N_ELEMENTS (KKC_KEY_EVENT_NAME_KEYVALS); entry_it = entry_it + 1) {
			KkcKeyEventNameKeyvalEntry entry = {0};
			entry = entry_collection[entry_it];
			{
				KkcKeyEventNameKeyvalEntry _tmp0_;
				guint _tmp1_;
				guint _tmp2_;
				_tmp0_ = entry;
				_tmp1_ = _tmp0_.key;
				_tmp2_ = keyval;
				if (_tmp1_ == _tmp2_) {
					KkcKeyEventNameKeyvalEntry _tmp3_;
					const gchar* _tmp4_;
					_tmp3_ = entry;
					_tmp4_ = _tmp3_.value;
					kkc_key_event_set_name (self, _tmp4_);
					break;
				}
			}
		}
	}
	{
		KkcKeyEventCodeKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = KKC_KEY_EVENT_CODE_KEYVALS;
		entry_collection_length1 = G_N_ELEMENTS (KKC_KEY_EVENT_CODE_KEYVALS);
		for (entry_it = 0; entry_it < G_N_ELEMENTS (KKC_KEY_EVENT_CODE_KEYVALS); entry_it = entry_it + 1) {
			KkcKeyEventCodeKeyvalEntry entry = {0};
			entry = entry_collection[entry_it];
			{
				KkcKeyEventCodeKeyvalEntry _tmp5_;
				guint _tmp6_;
				guint _tmp7_;
				_tmp5_ = entry;
				_tmp6_ = _tmp5_.key;
				_tmp7_ = keyval;
				if (_tmp6_ == _tmp7_) {
					KkcKeyEventCodeKeyvalEntry _tmp8_;
					gunichar _tmp9_;
					_tmp8_ = entry;
					_tmp9_ = _tmp8_.value;
					kkc_key_event_set_code (self, _tmp9_);
					break;
				}
			}
		}
	}
	_tmp10_ = self->priv->_code;
	if (_tmp10_ == ((gunichar) '\0')) {
		gboolean _tmp11_ = FALSE;
		guint _tmp12_;
		gboolean _tmp14_;
		_tmp12_ = keyval;
		if (((guint) 0x20) <= _tmp12_) {
			guint _tmp13_;
			_tmp13_ = keyval;
			_tmp11_ = _tmp13_ < ((guint) 0x7F);
		} else {
			_tmp11_ = FALSE;
		}
		_tmp14_ = _tmp11_;
		if (_tmp14_) {
			guint _tmp15_;
			_tmp15_ = keyval;
			kkc_key_event_set_code (self, (gunichar) _tmp15_);
		} else {
			const gchar* _tmp16_;
			_tmp16_ = self->priv->_name;
			if (_tmp16_ == NULL) {
				guint _tmp17_;
				GError* _tmp18_;
				_tmp17_ = keyval;
				_tmp18_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "unknown keysym %u", _tmp17_);
				_inner_error_ = _tmp18_;
				if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (self);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	_tmp19_ = keyval;
	kkc_key_event_set_keyval (self, _tmp19_);
	_tmp20_ = keycode;
	kkc_key_event_set_keycode (self, _tmp20_);
	_tmp21_ = modifiers;
	kkc_key_event_set_modifiers (self, _tmp21_);
	return self;
}


KkcKeyEvent* kkc_key_event_new_from_x_event (guint keyval, guint keycode, KkcModifierType modifiers, GError** error) {
	return kkc_key_event_construct_from_x_event (KKC_TYPE_KEY_EVENT, keyval, keycode, modifiers, error);
}


/**
         * Compare two key events ignoring modifiers.
         *
         * @param key a KeyEvent
         *
         * @return `true` if those base components are equal, `false` otherwise
         */
gboolean kkc_key_event_base_equal (KkcKeyEvent* self, KkcKeyEvent* key) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gunichar _tmp1_;
	KkcKeyEvent* _tmp2_;
	gunichar _tmp3_;
	gboolean _tmp7_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp1_ = self->priv->_code;
	_tmp2_ = key;
	_tmp3_ = _tmp2_->priv->_code;
	if (_tmp1_ == _tmp3_) {
		const gchar* _tmp4_;
		KkcKeyEvent* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = self->priv->_name;
		_tmp5_ = key;
		_tmp6_ = _tmp5_->priv->_name;
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp7_ = _tmp0_;
	result = _tmp7_;
	return result;
}


const gchar* kkc_key_event_get_name (KkcKeyEvent* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void kkc_key_event_set_name (KkcKeyEvent* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


gunichar kkc_key_event_get_code (KkcKeyEvent* self) {
	gunichar result;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_code;
	result = _tmp0_;
	return result;
}


static void kkc_key_event_set_code (KkcKeyEvent* self, gunichar value) {
	gunichar _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_code = _tmp0_;
	g_object_notify ((GObject *) self, "code");
}


guint kkc_key_event_get_keycode (KkcKeyEvent* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_keycode;
	result = _tmp0_;
	return result;
}


void kkc_key_event_set_keycode (KkcKeyEvent* self, guint value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_keycode = _tmp0_;
	g_object_notify ((GObject *) self, "keycode");
}


KkcModifierType kkc_key_event_get_modifiers (KkcKeyEvent* self) {
	KkcModifierType result;
	KkcModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


void kkc_key_event_set_modifiers (KkcKeyEvent* self, KkcModifierType value) {
	KkcModifierType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_modifiers = _tmp0_;
	g_object_notify ((GObject *) self, "modifiers");
}


guint kkc_key_event_get_keyval (KkcKeyEvent* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_keyval;
	if (_tmp0_ != KKC_KEYSYMS_VoidSymbol) {
		guint _tmp1_;
		_tmp1_ = self->priv->_keyval;
		result = _tmp1_;
		return result;
	} else {
		gboolean _tmp12_ = FALSE;
		gunichar _tmp13_;
		gboolean _tmp15_;
		{
			KkcKeyEventNameKeyvalEntry* entry_collection = NULL;
			gint entry_collection_length1 = 0;
			gint _entry_collection_size_ = 0;
			gint entry_it = 0;
			entry_collection = KKC_KEY_EVENT_NAME_KEYVALS;
			entry_collection_length1 = G_N_ELEMENTS (KKC_KEY_EVENT_NAME_KEYVALS);
			for (entry_it = 0; entry_it < G_N_ELEMENTS (KKC_KEY_EVENT_NAME_KEYVALS); entry_it = entry_it + 1) {
				KkcKeyEventNameKeyvalEntry entry = {0};
				entry = entry_collection[entry_it];
				{
					KkcKeyEventNameKeyvalEntry _tmp2_;
					const gchar* _tmp3_;
					const gchar* _tmp4_;
					_tmp2_ = entry;
					_tmp3_ = _tmp2_.value;
					_tmp4_ = self->priv->_name;
					if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
						KkcKeyEventNameKeyvalEntry _tmp5_;
						guint _tmp6_;
						_tmp5_ = entry;
						_tmp6_ = _tmp5_.key;
						result = _tmp6_;
						return result;
					}
				}
			}
		}
		{
			KkcKeyEventCodeKeyvalEntry* entry_collection = NULL;
			gint entry_collection_length1 = 0;
			gint _entry_collection_size_ = 0;
			gint entry_it = 0;
			entry_collection = KKC_KEY_EVENT_CODE_KEYVALS;
			entry_collection_length1 = G_N_ELEMENTS (KKC_KEY_EVENT_CODE_KEYVALS);
			for (entry_it = 0; entry_it < G_N_ELEMENTS (KKC_KEY_EVENT_CODE_KEYVALS); entry_it = entry_it + 1) {
				KkcKeyEventCodeKeyvalEntry entry = {0};
				entry = entry_collection[entry_it];
				{
					KkcKeyEventCodeKeyvalEntry _tmp7_;
					gunichar _tmp8_;
					gunichar _tmp9_;
					_tmp7_ = entry;
					_tmp8_ = _tmp7_.value;
					_tmp9_ = self->priv->_code;
					if (_tmp8_ == _tmp9_) {
						KkcKeyEventCodeKeyvalEntry _tmp10_;
						guint _tmp11_;
						_tmp10_ = entry;
						_tmp11_ = _tmp10_.key;
						result = _tmp11_;
						return result;
					}
				}
			}
		}
		_tmp13_ = self->priv->_code;
		if (((guint) 0x20) <= ((guint) _tmp13_)) {
			gunichar _tmp14_;
			_tmp14_ = self->priv->_code;
			_tmp12_ = ((guint) _tmp14_) < ((guint) 0x7F);
		} else {
			_tmp12_ = FALSE;
		}
		_tmp15_ = _tmp12_;
		if (_tmp15_) {
			gunichar _tmp16_;
			_tmp16_ = self->priv->_code;
			result = (guint) _tmp16_;
			return result;
		}
		result = KKC_KEYSYMS_VoidSymbol;
		return result;
	}
}


void kkc_key_event_set_keyval (KkcKeyEvent* self, guint value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_keyval = _tmp0_;
	g_object_notify ((GObject *) self, "keyval");
}


static KkcKeyEventCodeKeyvalEntry* kkc_key_event_code_keyval_entry_dup (const KkcKeyEventCodeKeyvalEntry* self) {
	KkcKeyEventCodeKeyvalEntry* dup;
	dup = g_new0 (KkcKeyEventCodeKeyvalEntry, 1);
	memcpy (dup, self, sizeof (KkcKeyEventCodeKeyvalEntry));
	return dup;
}


static void kkc_key_event_code_keyval_entry_free (KkcKeyEventCodeKeyvalEntry* self) {
	g_free (self);
}


static GType kkc_key_event_code_keyval_entry_get_type (void) {
	static volatile gsize kkc_key_event_code_keyval_entry_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_key_event_code_keyval_entry_type_id__volatile)) {
		GType kkc_key_event_code_keyval_entry_type_id;
		kkc_key_event_code_keyval_entry_type_id = g_boxed_type_register_static ("KkcKeyEventCodeKeyvalEntry", (GBoxedCopyFunc) kkc_key_event_code_keyval_entry_dup, (GBoxedFreeFunc) kkc_key_event_code_keyval_entry_free);
		g_once_init_leave (&kkc_key_event_code_keyval_entry_type_id__volatile, kkc_key_event_code_keyval_entry_type_id);
	}
	return kkc_key_event_code_keyval_entry_type_id__volatile;
}


static void kkc_key_event_name_keyval_entry_copy (const KkcKeyEventNameKeyvalEntry* self, KkcKeyEventNameKeyvalEntry* dest) {
	guint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	_tmp0_ = (*self).key;
	(*dest).key = _tmp0_;
	_tmp1_ = (*self).value;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).value);
	(*dest).value = _tmp2_;
}


static void kkc_key_event_name_keyval_entry_destroy (KkcKeyEventNameKeyvalEntry* self) {
	_g_free0 ((*self).value);
}


static KkcKeyEventNameKeyvalEntry* kkc_key_event_name_keyval_entry_dup (const KkcKeyEventNameKeyvalEntry* self) {
	KkcKeyEventNameKeyvalEntry* dup;
	dup = g_new0 (KkcKeyEventNameKeyvalEntry, 1);
	kkc_key_event_name_keyval_entry_copy (self, dup);
	return dup;
}


static void kkc_key_event_name_keyval_entry_free (KkcKeyEventNameKeyvalEntry* self) {
	kkc_key_event_name_keyval_entry_destroy (self);
	g_free (self);
}


static GType kkc_key_event_name_keyval_entry_get_type (void) {
	static volatile gsize kkc_key_event_name_keyval_entry_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_key_event_name_keyval_entry_type_id__volatile)) {
		GType kkc_key_event_name_keyval_entry_type_id;
		kkc_key_event_name_keyval_entry_type_id = g_boxed_type_register_static ("KkcKeyEventNameKeyvalEntry", (GBoxedCopyFunc) kkc_key_event_name_keyval_entry_dup, (GBoxedFreeFunc) kkc_key_event_name_keyval_entry_free);
		g_once_init_leave (&kkc_key_event_name_keyval_entry_type_id__volatile, kkc_key_event_name_keyval_entry_type_id);
	}
	return kkc_key_event_name_keyval_entry_type_id__volatile;
}


static void kkc_key_event_class_init (KkcKeyEventClass * klass) {
	kkc_key_event_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (KkcKeyEventPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_key_event_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_key_event_set_property;
	G_OBJECT_CLASS (klass)->finalize = kkc_key_event_finalize;
	/**
	         * The base name of the KeyEvent.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * The base code of the KeyEvent.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_CODE, g_param_spec_uint ("code", "code", "code", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * X keycode.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYCODE, g_param_spec_uint ("keycode", "keycode", "keycode", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Modifier mask.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_MODIFIERS, g_param_spec_enum ("modifiers", "modifiers", "modifiers", KKC_TYPE_MODIFIER_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYVAL, g_param_spec_uint ("keyval", "keyval", "keyval", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void kkc_key_event_instance_init (KkcKeyEvent * self) {
	self->priv = KKC_KEY_EVENT_GET_PRIVATE (self);
	self->priv->_keyval = KKC_KEYSYMS_VoidSymbol;
}


static void kkc_key_event_finalize (GObject* obj) {
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (kkc_key_event_parent_class)->finalize (obj);
}


/**
     * Object representing a key event.
     */
GType kkc_key_event_get_type (void) {
	static volatile gsize kkc_key_event_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_key_event_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcKeyEvent), 0, (GInstanceInitFunc) kkc_key_event_instance_init, NULL };
		GType kkc_key_event_type_id;
		kkc_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcKeyEvent", &g_define_type_info, 0);
		g_once_init_leave (&kkc_key_event_type_id__volatile, kkc_key_event_type_id);
	}
	return kkc_key_event_type_id__volatile;
}


static void _vala_kkc_key_event_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	switch (property_id) {
		case KKC_KEY_EVENT_NAME:
		g_value_set_string (value, kkc_key_event_get_name (self));
		break;
		case KKC_KEY_EVENT_CODE:
		g_value_set_uint (value, kkc_key_event_get_code (self));
		break;
		case KKC_KEY_EVENT_KEYCODE:
		g_value_set_uint (value, kkc_key_event_get_keycode (self));
		break;
		case KKC_KEY_EVENT_MODIFIERS:
		g_value_set_enum (value, kkc_key_event_get_modifiers (self));
		break;
		case KKC_KEY_EVENT_KEYVAL:
		g_value_set_uint (value, kkc_key_event_get_keyval (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_kkc_key_event_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	switch (property_id) {
		case KKC_KEY_EVENT_NAME:
		kkc_key_event_set_name (self, g_value_get_string (value));
		break;
		case KKC_KEY_EVENT_CODE:
		kkc_key_event_set_code (self, g_value_get_uint (value));
		break;
		case KKC_KEY_EVENT_KEYCODE:
		kkc_key_event_set_keycode (self, g_value_get_uint (value));
		break;
		case KKC_KEY_EVENT_MODIFIERS:
		kkc_key_event_set_modifiers (self, g_value_get_enum (value));
		break;
		case KKC_KEY_EVENT_KEYVAL:
		kkc_key_event_set_keyval (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



